#  Definicija razreda za komunikacijo z asteroidnim serverjem

import socket
import os
from sys import *
import select

#===========================================================================
#  Define a class to access asteroid_server
#===========================================================================
class Asteroid_client:
    #  Create a socket
    def __init__(self, host, port):
        self.port = port
        self.host = host
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    def connect(self):
        err = self.sock.connect_ex((self.host, self.port))
        #  If connection did not succeed, exit
        if err != 0:
            print 'Can not connect to server', self.host, 'at port', self.port
            print 'Reason:', os.strerror(err)
            exit()

    def get(self):
        return self.sock.recv(1024)
    
    def send(self, request):
        self.sock.send(request)

    def close(self):
        self.sock.close()
        
    def get_answer(self, timeout):
      
        ins = 1
        ans = ''
        #  The answer may be pretty long, so be ready to receive in parts
        while ins:
            #  Wait for the information
            a, b, c = select.select([self.sock], [], [], timeout)
            if len(a) > 0:
                ans1 = self.get()
                if len(ans1) == 0:
                    ins = 0
                ans = ans + ans1
                if ans[-1] == '\0':
                    ins = 0
            else:
                #  Timeout, end the loop
                ins = 0
        return ans
